#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Red
#property indicator_color2  Blue
#property indicator_color3  Aqua
#property indicator_color4  Magenta
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int    FractalPeriod   = 5;
extern int    PriceHigh       = PRICE_HIGH;
extern int    PriceLow        = PRICE_LOW;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav"; 

extern int    BOArrowSize     = 2;


double v1[];
double v2[];
double arrowUp[];
double arrowDn[];
double trend[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,v1);      SetIndexStyle(0,DRAW_ARROW);               SetIndexArrow(0,159); SetIndexLabel(0,"Resistance");
   SetIndexBuffer(1,v2);      SetIndexStyle(1,DRAW_ARROW);               SetIndexArrow(1,159); SetIndexLabel(1,"Support");
   SetIndexBuffer(2,arrowUp); SetIndexStyle(2,DRAW_ARROW,0,BOArrowSize); SetIndexArrow(2,241);
   SetIndexBuffer(3,arrowDn); SetIndexStyle(3,DRAW_ARROW,0,BOArrowSize); SetIndexArrow(3,242);
   SetIndexBuffer(4,trend);
   IndicatorShortName("Fractals - adjustable price breakout");
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            
   //
   //
   //
   //
   //
   
     int half = FractalPeriod/2;    
     for(int i=limit; i>=0; i--) 
     {
        bool   found     = true;
         double compareTo = iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i);
         for (int k=1;k<=half;k++)
            {
               if ((i+k)<Bars && iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i+k)> compareTo) { found=false; break; }
               if ((i-k)>=0   && iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i-k)>=compareTo) { found=false; break; }
            }
         if (found) v1[i] = iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i);
         else       v1[i] = v1[i+1];

         //
         //
         //
         //
         //
      
         found     = true;
         compareTo = iMA(NULL,0,1,0,MODE_SMA,PriceLow,i);
         for (k=1;k<=half;k++)
            {
               if ((i+k)<Bars && iMA(NULL,0,1,0,MODE_SMA,PriceLow,i+k)< compareTo) { found=false; break; }
               if ((i-k)>=0   && iMA(NULL,0,1,0,MODE_SMA,PriceLow,i-k)<=compareTo) { found=false; break; }
            }
         if (found) v2[i] = iMA(NULL,0,1,0,MODE_SMA,PriceLow,i);  
         else       v2[i] = v2[i+1];
         
         //
         //
         //
         //
         //
         
         trend[i] = trend[i+1];
         if (Close[i]>v1[i]) trend[i] = 1;
         if (Close[i]<v2[i]) trend[i] =-1;
         
         //
         //
         //
         //
         //
      
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
         if (trend[i]!= trend[i+1])
         if (trend[i] == 1)
               arrowUp[i] = Low[i]  - iATR(NULL,0,20,i)/2;
         else  arrowDn[i] = High[i] + iATR(NULL,0,20,i)/2;
     }
   manageAlerts();   
   return(0);
}
   
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Fractals - adjustable price breakout ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Fractals - adjustable price breakout "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

